%%  the corresponding PSF can be isotropic (the lateral and axial stepsize should be the same), the corresponding testing data should be interpolation to isotropic
clear all;

% ground truth path
pathMain_gt= 'OUTPUT/gt/';
number_of_simulation=1;

%output path
pathMain_no_noise_input= 'OUTPUT/input_no_noise/';
pathMain_noisy_input= 'OUTPUT/input_noise/';

% The blur function PSF path
PSFpath='PSF.tif';

I=double(ReadTifStack([pathMain_gt,'1.tif']));
[Sx, Sy, Sz] = size(I);
PSF = double(ReadTifStack(PSFpath));
PSF=PSF./sum(PSF(:));
PSF= align_size(PSF, Sx, Sy, Sz);
OTF= fftn(ifftshift(PSF));

for i=1:number_of_simulation
    ratio=5;% control the Poisson noise level
   I=double(ReadTifStack([pathMain_gt,num2str(i),'.tif']))*ratio;
   B=ConvFFT3_S(I,OTF);
   B1=poissrnd(B);
   E=max(B1(:));
   C=B1./E;
   sigma=0.5;%1.0*(rand()+0.1); % Control the level of Gaussian noise, constant or random value
   C=imnoise(C,'gaussian',0,sigma^2/E^2);
   C=C*E;

   WriteTifStack(B, [pathMain_no_noise_input,num2str(i),'.tif'], 32);
   WriteTifStack(C, [pathMain_noisy_input,num2str(i),'.tif'], 32);
   display(i);
end
