# 5#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Apr 19 17:10:32 2018

@author: lee
with batch normalization
"""
import datetime

import os
import sys
import time

import numpy as np
import tensorflow as tf
from RLN_single_Model import RLN_model, RLN_model_simple
import TF2ImageHelpers as images


base_dir = "/data"
ground_truthdir = base_dir + '/train/ground_truth/'
input_dir = base_dir + "/train/input/"

timestr = time.strftime("%Y%m%d-%H%M%S")
run_name = "/{}/".format(sys.argv[1])

train_model_path = base_dir + '/train/model_rl' + run_name
train_output = base_dir + '/train/output_rl' + run_name
test_output = base_dir + '/test/output_rl' + run_name
log_dir = base_dir + "/logs" + run_name
print(test_output)

if not os.path.exists(train_model_path) or not os.path.exists(train_output) or not os.path.exists(test_output) or not os.path.exists(log_dir):
    raise Exception("missing locations")

import logging
logging.basicConfig(filemode="a",encoding='utf-8', level=logging.DEBUG)


number_of_images_to_load =100 #set to -1 for all images
epochs = 40


model = RLN_model_simple(name="test")




i = tf.Variable(0, trainable=False, dtype=tf.int64)

ckpt = tf.train.Checkpoint(step=i, model=model)
manager = tf.train.CheckpointManager(ckpt, train_model_path, max_to_keep=5)
ckpt.restore(manager.latest_checkpoint)
logging.info("restore successful")
with tf.device('/CPU:0'):
    dataset_original, (_,_) = images.move_dataset_to_mem(input_dir, ground_truthdir, number_of_images_to_load)
    dataset_original = dataset_original.batch(1)

for x,y in dataset_original:
    st = time.time()
    x_i = model(x,training=False)
    et = time.time()
    dt = np.array(et-st)
    np.savez_compressed(test_output+str(i.numpy())+".npz",x = x, f_x=x_i[0],y=y,dt=dt)
    et2 = time.time()
    i.assign_add(1)
    logging.info("Run: {} calc time: {} save time: {} memory: {}".format(i.numpy(), dt, et2-et,tf.config.experimental.get_memory_info('GPU:0')))