## How to Determine the PSF
The PSF is used to generate synthetic data to be used during the training process. Using the PSF we can model the effects of the camera on real world objects. Thus we can generate realistic input images from ground truths.

### Measurement
We did the measurements using a laser and A 1.4 um pinhole. This was barely smaller than the pixel size of the CCD. Thus we used the lens in 1:1 magnification mode at ca. 50 cm distance from the pinhole. We took 50 images per measurement and did 8 measurements with the light shining on different parts of the lens.

### Analysis
The code is divided into three parts:
1. preprocess_PSF.py: This combines the 50 pictures into a single averaged picture for each measurement. Done only once during the process.
2. PSF.py: This script actually calculates the PSF from the averaged images created in the last step. This is done by cropping the image to a (2\*delta+1 x 2\*delta+1) square around the brightest point and normalizing the output according to the L1 norm.
3. merge_PSF.py: This combines the output of the PSF.py for each measurement into a combined PSF and generates graphs. 

Read the relevant scripts for more details