import numpy as np
from matplotlib import pyplot as plt
import cv2

"""
This script is used to merge the outputs of PSF.py. It merges the outputs by averaging and plots the individual PSFs.  
"""

b = []
fig, axs = plt.subplots(2, 4)
for i in range(1,9):
    plot_index = np.unravel_index(i-1,axs.shape)
    path = ("../data/focus1/{}/".format(i))
    a = np.load(path+"cropped.npy")
    print(a.shape)
    b.append(a)

    axs[plot_index].set_title("PSF of {}".format(i))
    axs[plot_index].imshow(a)

fig.show()

b = np.array(b)
b = np.mean(b,axis=0)
normed = np.zeros(np.shape(b), dtype=np.float64)
cv2.normalize(b, normed, 1.0, 0, cv2.NORM_L1)

fig,ax = plt.subplots(1)
ax.set_title("Point Spread Function of the camera")
heatmap = ax.pcolor(normed)
ax.colorbar(heatmap)
fig.show()

print("L1 Norm is {}".format(np.sum(normed)))
np.save("avg_psf",normed)
print(b.shape)
