from helpers.image import show_image,read_y10

import os
import cv2
import numpy as np
import matplotlib.pyplot as plt

from helpers.output import save_array
"""
This script reads PSF measurements in Y10 format and averages the measurements for each position.  I.E: It averages over all y10 images in a folder and outputs the average image as npz.
"""
for i in range(1,2):
    path = ("../data/focus1/{}/".format(i))
    print(path)
    a = os.listdir(path)
    a = [i for i in a if i.split('.')[-1] == 'y10']
    a = sorted(a,key = lambda x : int(x.split(".")[0]))

    images = [path+i for i in a]

    image = read_y10(images[0])


    datas = np.zeros((len(images),image.shape[0],image.shape[1]),dtype=np.float64)

    for i ,path_i in enumerate(images):
        loaded = read_y10(path_i)
        datas[i,:,:] = loaded / ((2**10) - 1)
        #datas[i,:,:] = loaded
    print(datas.shape)
    avg_image = np.mean(datas,axis=0,dtype=np.float64)
    print(avg_image.dtype)



    save_array(path+"avg_image.npz",avg_image)
