#!/bin/bash

counter_file="image_counter.txt"

# Check if the counter file exists, if not, create it with initial value 1
if [ ! -f "$counter_file" ]; then
    echo "1" > "$counter_file"
fi

# Read the current run number from the counter file
run_number=$(<"$counter_file")

# Create a new file with the current run number
mkdir "$run_number"

(cd "$run_number"

for (( i = 0; i < $1; i++ )) ; do
  v4l2-ctl --stream-mmap --stream-count=1 -d /dev/video0 --stream-to="${i}.y10" --set-fmt-video pixelformat="Y10 "

done)

# Increment the run number for the next run
((run_number++))

# Update the counter file with the new run number
echo "$run_number" > "$counter_file"