import os

import cv2
import numpy as np

from helpers.image import read_y10

path = ("../data/focus1_1/1um/long/run1/")
print(os.getcwd())
a = os.listdir(path)
a = sorted(a, key=lambda x: int(x.split(".")[0]))
"""
This is a script to convert Y10 images or images in y10 arrays on the path to png images. Normalized to (0,1).
"""
for i in a:
    if i.split('.')[-1] == 'y10':
        image = read_y10(path + i)
        cv2.normalize(image,image,0,1,cv2.NORM_MINMAX)
        cv2.imwrite(path+i+".png",image)

    if i.split('.')[-1] == 'npz':
        arrays = np.load(path + i)
        for subarray in arrays.files:
            image = arrays[subarray]
            print(image.shape)
            if image.ndim == 2 or image.ndim == 3:
                cv2.normalize(image, image, 0, 1, cv2.NORM_MINMAX)
                cv2.imwrite(path+"{}_{}.png".format(i,subarray),image)
            if image.ndim == 4:
                for j in range(image.shape[0]):
                    cv2.normalize(image[j,:,:,:], image[j,:,:,:], 0, 1, cv2.NORM_MINMAX)
                    cv2.imwrite(path+"{}_{}_{}.png".format(i,subarray,j),image[j,:,:,:])