import os

import cv2
import matplotlib.pyplot as plt
import numpy as np

from helpers.image import show_image
"""
This script is used to display the output of the inference that runs on the server. The script 
RLN_single_inference.py outputs .npz files with the arrays "x" for input, "dt" for calculation time, and "f_x" for 
inference output. This display x and f_x for all .npz s in the path.
"""
path = "/home/guney/Project/Richardson-Lucy-Net/data from server/traind model 2d/inference_output_2/"
a = os.listdir(path)
a = [i for i in a if i.split('.')[-1] == 'npz']
a = sorted(a,key = lambda x : int(x.split(".")[0]))
a = [path + i for i in a]
display = True
delta = 800




for i,data in enumerate(a):
    print("==========================================================")
    print(data)
    print("==========================================================")

    data = np.load(data,allow_pickle=True)
    inference = data["f_x"][0][:,:,0]
    input = data["x"][0,:,:,0]
    print(np.max(inference))
    print(inference.dtype)
    shape = inference.shape
    print("Read: max: {} , min: {}, mean: {}".format(np.max(inference),np.min(inference),np.mean(inference)))
    inference = np.clip(inference,0,1)
    inference = inference[shape[0]//2-delta:shape[0]//2+delta,shape[1]//2-delta:shape[1]//2+delta]
    # cv2.normalize(inference, inference, 0, 1.2, cv2.NORM_MINMAX)
    input = input[shape[0]//2-delta:shape[0]//2+delta,shape[1]//2-delta:shape[1]//2+delta]
    # cv2.normalize(input, input, 0, 1,cv2.NORM_MINMAX)
    # cv2.imwrite("{}_inference.jpg".format(i),inference)
    # cv2.imwrite("{}_input.jpg".format(i),input)
    print(inference.dtype)

    if display:
        show_image(inference,"inference",500,500)
        cv2.moveWindow("inference",900,000)
        show_image(input,"input",500,500)
        print(np.max(inference),np.min(inference))


        if cv2.waitKey() == ord('c'):
            print("exiting")
            cv2.destroyAllWindows()
            exit(0)

    print("==========================================================")


