import os

import cv2
import numpy as np

from helpers.image import read_y10, show_image

"""
This script is used to prepare the y10 files from the camera for the neural network. It reads the y10 file, 
converts it into float32 representation, normalizes it to (0,1) and inverts the image. The network works best on 
white features on black background.
"""
i = 1
path = ("/media/guney/9E79-C5A1/photos/ind2/")
output= "test/photosind2/"
if not os.path.exists(output):
    os.makedirs(output)
print(os.getcwd())
a = os.listdir(path)
a = [i for i in a if i.split('.')[-1] == 'y10'][:]
a = sorted(a,key = lambda x : int(x.split(".")[0]))

for i,path_i in enumerate(a):
    print(path_i)
    datat = (read_y10(path+path_i)/ ((2**10) - 1))
    print("Read: max: {} , min: {}, mean: {}".format(np.max(datat),np.min(datat),np.mean(datat)))


    cv2.normalize(datat,datat,0,1,cv2.NORM_MINMAX)
    show_image(datat,"image_normed")

    datat = 1- datat
    print("Out: max: {} , min: {}, mean: {}".format(np.max(datat),np.min(datat),np.mean(datat)))
    np.savez_compressed(output+str(i) + ".npz",datat)
    show_image(datat,"image")
    if cv2.waitKey(0) == ord('c'):
        exit(0)